program provaio
  implicit none
  integer, parameter :: n=256
  integer :: i,j,k
  real :: time1, time2
  real, dimension(n,n,n) :: A

  call random_number(A)

  open(unit=79,file="perelemento.bin",form='unformatted')

  A = A + 1.0

  call cpu_time(time1)

  do k=1,n
    do j=1,n
      do i=1,n
        write(79) a(i,j,k)
      enddo
    enddo
  enddo

  call cpu_time(time2)
  close(79)

  write(*,*) 'tempo per elemento', time2-time1

  A = A + 2.0

  open(unit=79,file="perelementoimplicit.bin",form='unformatted')
  call cpu_time(time1)

  write(79) (((a(i,j,k), i=1,n), j=1,n), k=1,n)

  call cpu_time(time2)
  write(*,*) 'tempo per elemento implicit' , time2-time1

  close(79)

  A = A + 3.0

  open(unit=79,file="whole.bin",form='unformatted')
  call cpu_time(time1)

  write(79) a

  call cpu_time(time2)
  write(*,*) 'whole' , time2-time1

  close(79)

  A = A + 4.0
  
  open(unit=79,file="stride.bin",form='unformatted')
  call cpu_time(time1)

  write(79) a(1:n,1:n,1:n)

  call cpu_time(time2)
  write(*,*) 'whole' , time2-time1

end program provaio
